/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *
 * The initial developer of the code is Andy Edmonds.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Edmonds <aedmonds@mindspring.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var numFolders = 0;
var docHTML = "";
var crumbNames = new Array(1);
var crumbNodes = new Array(1);
var lastFolderName = "";
var lastFolderNode = "";
var loadInProgress = false;
var count = 0;
  	var thirdLevCount = 0;
	var pathLabel = new Array(1);
var pathNode = new Array(1);
	
	
  function countFolders(node) {
	dump("\n\n counting folders for " + node.Value );
	if (RDFCUtils.IsContainer(Bookmarks, node)) {
     // It's a folder
		try {
	      var name = Bookmarks.GetTarget(node, kNC_Name, true);
		} catch(e) { dump("get target failed \n"); }
	
	    RDFC.Init(Bookmarks, node);
	    var contents = RDFC.GetElements();
	    while (contents.hasMoreElements()) {
	      var child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
		  if(RDFCUtils.IsContainer(Bookmarks, child)) numFolders++;	
		  
		}
			
	 }
	 dump(" and found " + numFolders + " \n\n");
  }

	
  function walk(node,  curDepth, parent) {
  	var marksContainer = document.getElementById("folders");
	var myNode, lastNode;
	var folderProto = document.getElementById("proto_div_folder");
	var subFolderProto = document.getElementById("proto_div_subfolder");
	var folderTitle = "";
	
  	if(!parent) {
		parent = document.getElementById("proto_div_folder");
	}

  	if(!curDepth) curDepth = 1;
   //dump("\n\n walking node " + node.Value + " \n\n");
	if (RDFCUtils.IsContainer(Bookmarks, node)) {
     // It's a folder
		try {
			//dump("count is " + RDFC.GetCount() );
	      var name = Bookmarks.GetTarget(node, kNC_Name, true);
		  var description =  Bookmarks.GetTarget(node, kNC_Description,true);
		} catch(e) { dump("get target failed \n"); }
	      if (name) {
		  	// Top folder level
		  	if(curDepth == 2) {
			count++;
			 lastFolderName = name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			 lastFolderNode = node.Value;
		   folderTitle = name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
		   myNode = folderProto.cloneNode(true);
		   myNode.setAttribute("ref",node.Value);
		   myNode.setAttribute("depth",crumbNames.length+1);
		   myNode.setAttribute("title",escape(name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value));
		   dump(">->-> set title to " + escape(description) + " " + myNode.getAttribute("title") + "\n");
		   myNode.setAttribute("type","folder");
		   docHTML = "<b>" + name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + " (" + RDFC.GetCount() + ")";
		   docHTML +="</b>";
			myNode.innerHTML =  docHTML;
			parent.appendChild(myNode);
			subParent = myNode;
			myNode.addEventListener("click", loadNode, false);
		   } else {
		   		if(curDepth == 1) {
					// Root, just loop
				} else {
		   // DEPTH = 3
		   // Subfolder, invokes skipnode load function
		   myNode = subFolderProto.cloneNode(true);
		   myNode.setAttribute("ref", node.Value);
		   myNode.setAttribute("depth",crumbNames.length+1);
		   myNode.setAttribute("title", escape(name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value));
		   myNode.setAttribute("type","folder");
		   
		   docHTML = "<b>" + name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + " (" + RDFC.GetCount() + ")";
		   docHTML +="</b>";
			myNode.innerHTML =  docHTML;
			parent.appendChild(myNode);
			myNode.addEventListener("mousedown", skipNode, false);
			

		   //}
		   }
		   }
		  }
	
	      RDFC.Init(Bookmarks, node);
	      var contents = RDFC.GetElements();
	      while (contents.hasMoreElements()) {
	        var child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	
			if(curDepth < 3) {
			
	        walk(child,  curDepth+1, parent);
	
			}
			
	      }
		 if(curDepth == 2) {
		 // dump(" considering td " + count + " vs " + Math.round(numFolders/2) + "\n");
		  if(count == Math.round(numFolders/2)) dump("folder split");//docHTML +="</td><td valign='top'>";
		    //dump("numfolders is " + numFolders + "versus " + count + "\n");	   		
	      } 
		}
  }

  
    function walkMarks(node) {

	//if(count > 100) {return false};
    dump("\n\n walking node " + node.Value + " \n\n");
	if (RDFCUtils.IsContainer(Bookmarks, node)) {
     // It's a folder
		try {
	      var name = Bookmarks.GetTarget(node, kNC_Name, true);
		} catch(e) { dump("get target failed \n"); }
	
	      RDFC.Init(Bookmarks, node);
	      var contents = RDFC.GetElements();
	      while (contents.hasMoreElements()) {
	        var child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);				
				//dump("rendering walk \n");
     	        currentLevelMarks(child);
				
	      }		 
	    }

  }
  

  
function currentLevelMarks(node) {
	var marksContainer = document.getElementById("marks");
	var markProto = document.getElementById("proto_div_link");
	var test = "";
   var myNode;
   // dump("\n\n func curlevel marks at " + node.Value + " \n\n");
	if (!RDFCUtils.IsContainer(Bookmarks, node)) {
      // It's just a bookmark.	  
	  try {
		myNode = markProto.cloneNode(true);
		docHTML = "<a href='" + Bookmarks.GetTarget(node, kNC_URL, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value+ "' ";
		docHTML += ">";
		docHTML += Bookmarks.GetTarget(node, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value ;
 docHTML += "<a>";
 		myNode.innerHTML = docHTML;
		marksContainer.appendChild(myNode);
		
	} catch(e) {
	//	for(i in Bookmarks) dump(i + "\n");
		//dump("failed on bookmark " +  e + "\n\n \n");
		//for(i in Bookmarks.QueryInterface)  dump(i + " in QI \n");
	}	
    }

}
function buildCrumb() {
	mystr = "";
	dump("\n\n --- CRUMBS --- \n " +  pathNode + "\n " + pathLabel + " crumbs \n\n");
	if(pathNode.length) {
	for(var i=1;i<pathNode.length -1;i++) {
		dump(pathLabel[i] + "is pathlabel\n");
		mystr+= "<span type=\"breadcrumb\" ref=\"" + pathNode[i] + "\" depth =\"" + i + "\">" + pathLabel[i] + "</span>  >> ";		
	}
		document.getElementById("breadcrumb").innerHTML = mystr;
	}
	dump("Crumb is " + mystr + "\n");
}

function loadHome() {
	initVars();
	mozhooInit(kNC_BookmarksRoot);
	crumbNames = new Array(1);
	crumbNodes = new Array(1);
}

function initVars() {
  	thirdLevCount = 0;
	numFolders = 0;
    docHTML = "";
	count = 0;
}

 
function breadCrumbNav(evt) {
	evt.stopPropagation(); 
	dump(evt.target);
	// Don't add new folder name to breadcrumb UP ops
	var ele = walkUpForFolderSpan(evt.target);
	
	if(!isUndefined(ele) && ele != false) {
	
	depth = ele.getAttribute("depth");
	dump(ele + " of depth " + depth + " vs " + pathNode.length + "\n");
	if(depth <= pathNode.length-1) {
		for(var i=pathNode.length-1;i>depth;i--) {
			pathNode.pop();
			pathLabel.pop();
		}
	skip = true;
	}
	dump(pathNode + " " + pathLabel + " \n");
	loadNode(evt, true);
	}

}

// clearEmpties removes branch from paths
// in the case of a breadcrumb upward navigation
function clearEmpties() {
	for(var i=0; i<pathNode.length;i++) {
		if(pathNode[i].length == 0) pathNode.pop();
	}	
	for(i=0; i<pathLabel.length;i++) {
		if(pathLabel[i].length == 0) pathLabel.pop();
	}	
	
}	
function skipNode(evt) {
	// skip flag is used to note a sub-category navigation
	
	var ele = walkUpForFolderSpan(evt.target);
	var parent = walkUpForFolderDiv(evt.target)
	dump("--------skipping node " + ele + " " + ele.id + " with parent " + parent + " " + parent.id + " \n\n");
	if(ele != false && !isUndefined("ele")) {
		dump("found folder " + parent + " and ele " + ele +" \n");
		evt.stopPropagation(); 
		clearEmpties();
		title = ele.getAttribute("title");
		depth = ele.getAttribute("depth");
		pathNode.push(parent.getAttribute("ref"));
		dump("parent of skipped node is " + parent.getAttribute("title") + "\n");
		pathLabel.push(parent.getAttribute("title"));
		loadNode(evt);
	}
}

// ele, title, depth
function loadNode(evt, skip) {
	
	dump("-----loading node with " + evt + " and target of " + evt.target + "\n");
	//dump(evt.target.tagName + " is evt src tag" );
		ele = walkUpForFolder(evt.target);
	
	dump("loadNode found " + ele + " " + ele.id + "\n")
	if(!isUndefined(ele) && ele != false) {
	evt.stopPropagation();
	title = ele.getAttribute("title");
	depth = ele.getAttribute("depth");

	dump("\n\nLOAD EVENT\n ele is " + ele + " with title " + title + "\n");
	dump("fresh load \n\n " + ele.getAttribute("ref") + " is ref. \n\n Depth is " + depth +  " vs total" + pathNode.length);
	evt.stopPropagation(); 
	}
	dump("test is " + ele   + "\n")
	if(ele && !skip && !isUndefined(ele) && !isUndefined(ele.hasAttribute)  && ele.hasAttribute("ref") ) {
		dump("\n\\Starting from " + pathNode + " " +  pathLabel + "\n");
		dump("\n\\Extending crumb with " + ele.getAttribute("ref") + " " + title + " \n");
		// Len check hack, shoudln't be necessary
		//if(title.length) {
		pathNode.push(ele.getAttribute("ref"));
		dump("Pushing " + title + " to pathlabel\n");
		pathLabel.push(title);
		//}
	} 

	dump("pathNode is " + pathNode + "\n\n\n")
	document.location ="mozhoo.html?nodes=" + escape(pathNode.join( ",")) + "&labels=" + pathLabel.join( ",");

	
}


function mozhooInit() {
	dump("\n\n\n||||||||||||||||||||||||||||||||||||INIT MOZHOO|||||||||||||||||||||||||||||||\n\n");
	dump("URL: " + location.search + "\n\n");
	if(location.search != "") {
		dump("parsing url params " + typeof(parseQueryString("labels")) + "\n")
		var paths = parseQueryString("labels");
		pathLabel = paths.split(",");
		var nodes = parseQueryString("nodes");
		pathNode = nodes.split(",");
		dump("---label is " + pathLabel + " " + pathLabel.length +" \n---and path is " + pathNode + " " + pathNode.length + "\n");
		node = pathNode[pathNode.length-1];
		dump("resolving node to " + node + "\n");
		buildCrumb();
		document.title ="MozHoo:  " + paths;
	} else {
		dump("Resetting Path to Root \n")
		path="Home";
		node="NC:BookmarksRoot";;
		pathNode[0] = "NC:BookmarksRoot";
		pathLabel[0] = "Home"; 
	}
	dump("Initing node " + node + "\n");
	node =  RDF.GetResource(node);
	 

	countFolders(node);

	walk(node);
	docHTML +="</td></tr></table>";
	document.getElementById('folders').innerHTML = docHTML;
	//addListeners();
	docHTML="";
	walkMarks(node);				
		
	dump("Drawing \n");
	dump("\n\n\n||||||||||||||||||||||||||||||||||||END RENDER MOZHOO|||||||||||||||||||||||||||||||\n\n");
	dump("\n\nPaths are " + pathNode + " " + pathLabel + "\n\n");

}


  

function mozhooBookmarkFindStub() {
	var myText = document.getElementById("mozhoo_criteria").value;
	mozhooBookmarkFind("&method=contains&match=http://home.netscape.com/NC-rdf#Name&text=" + myText);
}

function mozhooBookmarkByUrl(addy) {
	//if(addy.indexOf('http')
	var offset;
	params = "&method=contains&match=http://home.netscape.com/NC-rdf#URL&text=" + addy;
    var searchURI = "find:datasource=rdf:bookmarks" + params;
	var arResult = new Array(1);
    var searchURI = "find:datasource=rdf:bookmarks" + params;
	//dump("Processing " + searchURI + "\n");
	var	resultMarkDS = RDF.GetDataSource("rdf:localsearch");
  	var node = RDF.GetResource(searchURI);
	resultMarks= resultMarkDS.GetTargets(node, kNC_child, true);
    while (resultMarks.hasMoreElements()) {
        var child = resultMarks.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
  	    //dump(child.Value + " val\n");
		offset = arResult.length;
		arResult[offset] = new Object;
		arResult[offset].url = Bookmarks.GetTarget(child, kNC_URL, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value+ "' ";
		arResult[offset].name = Bookmarks.GetTarget(child, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value ;
	dump("Found " + arResult[offset].url + " " + arResult[offset].name + "\n");
    }
	return arResult;
}

function mozhooBookmarkByName(addy) {
	//if(addy.indexOf('http')
	var offset;
	params = "&method=contains&match=http://home.netscape.com/NC-rdf#Name&text=" + addy;
    var searchURI = "find:datasource=rdf:bookmarks" + params;
	var arResult = new Array(1);
    var searchURI = "find:datasource=rdf:bookmarks" + params;
	//dump("Processing " + searchURI + "\n");
	var	resultMarkDS = RDF.GetDataSource("rdf:localsearch");
  	var node = RDF.GetResource(searchURI);
	resultMarks= resultMarkDS.GetTargets(node, kNC_child, true);
    while (resultMarks.hasMoreElements()) {
        var child = resultMarks.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
  	    //dump(child.Value + " val\n");
		offset = arResult.length;
		arResult[offset] = new Object;
		arResult[offset].url = Bookmarks.GetTarget(child, kNC_URL, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value+ "' ";
		arResult[offset].name = Bookmarks.GetTarget(child, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value ;
	dump("Found " + arResult[offset].url + " " + arResult[offset].name + "\n");
    }
	return arResult;
}


