/* 
This work is licensed by the Creative Commons
Attribution-NonCommercial-ShareAlike 1.0

Key License Terms:
Attribution. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees must give the original author credit.

Noncommercial. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees may not use the work for commercial purposes -- unless they get the licensor's permission.

Share Alike. The licensor permits others to distribute derivative works under a license identical to the one that governs the licensor's work.

http://creativecommons.org/licenses/by-nc-sa/1.0

Visit http://www.blozom.com for commercial licensing terms.  
Copyright 2003, Uzilla LLC
*/

// put listLast, etc here

function dumpXML(xml, len) {
	 var output = new DOMParser().parseFromString(blozomCategoryXML, "text/xml");
	dump("\n\nXML CONTENT\n" + output + "\n\n");
}

function xmlEscape(myText) {
	myText = replaceAll(myText, "<", "&lt;");
	myText = replaceAll(myText, ">", "&gt;");
	myText = replaceAll(myText, "&", "&amp;");
	dump("returning xml escaped " + myText + "\n");
	return myText;	
}

function xmlUnescape(myXML) {
	myText = replaceAll(myXML, "&lt;", "<");
	myText = replaceAll(myXML, "&gt;", ">");
	myText = replaceAll(myXML, "&amp;", "&");
	dump("returning xml escaped " + myXML + "\n");
	return myXML;
}

function replaceAll(myString, mySubString, myNewString) {
	if(myString != 'undefined') {
		dump("Replacing in " + myString + " this " + mySubString + " with " + myNewString + "\n");
		if(myString.length > 0) {
			while(myString.indexOf(mySubString) > -1) {
				//dump("repped " + myString + "\n");
				myString = myString.replace(mySubString, myNewString);
		}
		return myString;
	} else {
		return '';
	}
	}
}

function listLast(list, separator) {
	if(!separator) separator = blozomFileSeparator
	var arList = list.split(separator);
	return arList[arList.length - 1];
}

function blozomPublishPathFromDataPath(path) {
	return path.replace(blozomDataPath, blozomPublishPath);
}

function listLen(mylist, separator) {
	var arList = mylist.split(separator);
	return arList.length;
}

function isMonthFolder(strPath) {
	
	strPath = strPath.replace(blozomDataPath,"");
	strPath = strPath.replace(blozomPublishPath, "");
	var arPath = strPath.split(blozomFileSeparator);
	
	if(arPath.length == 3 && blozomIsBlogFolder(strPath)){
		dump("A month folder. ");
		return true;
	} else {
		dump("Not A month folder. ");
		return false;
	}
}


function isDayFolder(strPath) {
	dump("Path is " + strPath + " vs " + blozomDataPath + "\n");
	strPath = strPath.replace(blozomDataPath,"");
	strPath = strPath.replace(blozomPublishPath, "");
	var arPath = strPath.split(blozomFileSeparator);
	dump("Is Day?  " + arPath.length + "\n");
	if(arPath.length == 4 && blozomIsBlogFolder(strPath)){
		dump("A day folder. ");
		return true;
	} else {
		dump("Not A day folder. ");
		return false;
	}
}

function getMonthFromPath(strPath) {
	dump("Finding month in " + strPath + "\n");
	strPath = strPath.replace(blozomDataPath,"");
	var arPath = strPath.split(blozomFileSeparator);
	for(i in arPath) dump("getting month " + i + " " + arPath[i] + "\n");
	return arPath[2];

}
function getYearFromPath(strPath) {
	//dump("Finding year in " + strPath + "\n");
	strPath = strPath.replace(blozomDataPath,"");
	var arPath = strPath.split(blozomFileSeparator);
	//for(i in arPath) dump("getting month " + i + " " + arPath[i] + "\n");
	return arPath[1];

}

function blozomIsBlogFolder(strPath) {
	//dump("Checking for blog folder on " + strPath )
	if(strPath.length) {
	if(strPath.indexOf('2003') > -1 || strPath.indexOf('2002') > -1) {
		//dump(" TRUE \n");
		return true;
	} else {
		//dump(" FALSE \n");
		return false;
	}
	} 
}


function structCount(obj) {
	var counter = 0;
	for(i in obj) counter++;
	return counter;
}

function getPostTimingFromPath(strPath) {
	var count = 0;
	var timingObj = new Object();
	var arPath = strPath.split("/");
	for(var i=0;i<arPath.length;i++) {
		if(blozomIsBlogFolder(arPath[i])) {
			count = 1;
			timingObj.year = arPath[i];
		}
		if(count == 2) timingObj.month = arPath[i];
		if(count == 3) timingObj.day = arPath[i];	
		if(count > 0) count++;	
	}
	dump("returning " + timingObj.year + "/" + timingObj.month + "/" + timingObj.day+ "/\n");
	return timingObj;
}


function showMap(strYear) {
	dump("xfml node is " + xfmlRoot + " " + xfmlRoot.nodeName + "\n" + xfmlRoot.childNodes.item(0).nodeName + "\n");
	var itemNode, title, permalink;
	var indexContent;
	//var indexMonthContent;
	var timingObj;
	var curMonth = '';
	var curDay = '';
	try {
		var blogNodes =  xfmlRoot.childNodes.item(0).childNodes.item(1);
		for(var i=1; i<blogNodes.childNodes.length;i++) {
			//dump("pubbing item \n");
			itemNode = blogNodes.childNodes.item(i); 
			//dump("title is " + itemNode.childNodes.item(0).childNodes.item(0).nodeName + "\n");
			title = itemNode.childNodes.item(0).childNodes.item(0).nodeValue;
			permalink = itemNode.childNodes.item(2).childNodes.item(0).nodeValue;
			dump("Found " + title + " with " + permalink + "\n");		
			timingObj = getPostTimingFromPath(permalink);
			if(timingObj.month != curMonth) {
				curMonth = timingObj.month + '';
				indexContent += addIndexMonth(curMonth);
				curDay = '';
			}
			if(timingObj.day != curDay) {
				curDay = timingObj.day + '';
				indexContent += addIndexDay(curDay);
			}
			
			indexContent += addIndexContent(title, permalink);		
		} 
	}
	catch (err) {
		dump("ERROR: " + err + "\n In year/month archive \n");
	}
	//dump(indexContent);

}


// Extracts pubdate and title from a .xml blog post file
// Returns: contenObj -> .pubdate, .title, .categories
function blozomMetaForPublish(filePath) {
	var contentObj = new Object;
	dump("   Extracting metadata for " + filePath + "\n");
	var tempFile = new File(filePath);
	tempFile.open("r");
	var xmlContent = tempFile.read();
	//dump("XML is " + xmlContent + "\n");
	var metaData = new DOMParser().parseFromString(xmlContent, "text/xml");
	var title = metaData.childNodes.item(0).childNodes.item(0).childNodes.item(0).childNodes.item(0).data;
	dump("Gettign post of title " + title + "\n");
	contentObj.title = title;
	var item = metaData.childNodes.item(0).childNodes.item(0)
	contentObj.categories = new Object();
	if(item.childNodes.length > 0) contentString += "Published in: ";
	try {
	for(var i=0;i< item.childNodes.length;i++) {
		//dump(item.childNodes.item(i).nodeName + "\n");
		if(item.childNodes.item(i).nodeName == "category") {
			contentObj.categories[ item.childNodes.item(i).childNodes.item(0).nodeValue] = 1;
		}
		if(item.childNodes.item(i).nodeName == "pubdate") {
			contentObj["pubdate"] = item.childNodes.item(i).childNodes.item(0).nodeValue;
		}
	} 
	} catch(err) {
	dump(err + "error trapped in blogpost footer\n");
	}
	return contentObj;
}